## debputy 0.1.80

=== Makefile ===
#!/usr/bin/make -f

DEBPUTY_INSTALLED_ROOT_DIR=/usr/share/dh-debputy
DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR=/usr/share/debputy/

subs = -e 's|^$1 = .*|$1 = $2|'

# Nothing to do by default
all:

check:
	py.test -v

install:
	install -m0755 -Dt$(DESTDIR)/usr/bin dh_debputy dh_installdebputy assets/debputy
	install -m0755 -Dt$(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR) deb_packer.py deb_materialization.py
	install -m0644 -Dt$(DESTDIR)/usr/share/perl5/Debian/Debhelper/Sequence lib/Debian/Debhelper/Sequence/*.pm
	install -m0644 -Dt$(DESTDIR)/usr/share/perl5/Dpkg/BuildDriver lib/Dpkg/BuildDriver/*.pm
	cp -a --reflink=auto src/debputy $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)
	install -m0755 -d $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)
	cp -a --reflink=auto debputy $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)
	sed -i \
	   $(call subs,_VERSION,"$(shell dpkg-parsechangelog -SVersion)") \
	   $(call subs,DEBPUTY_ROOT_DIR,pathlib.Path("$(DEBPUTY_INSTALLED_ROOT_DIR)")) \
	   $(call subs,DEBPUTY_PLUGIN_ROOT_DIR,pathlib.Path("$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)")) \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/deb_materialization.py \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/deb_packer.py \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy/version.py
	find $(DESTDIR)/usr/share/dh-debputy -type d -name '__pycache__' -exec rm -fr {} +
	install -m0755 -d $(DESTDIR)/usr/share/man/man1
	pod2man --utf8 --section=1 --name="debputy" -c "The debputy Debian packager helper stack" debputy.pod \
	   $(DESTDIR)/usr/share/man/man1/debputy.1
	pod2man --utf8 --section=1 --name="dh_debputy" -c "The debputy Debian packager helper stack" dh_debputy \
	   $(DESTDIR)/usr/share/man/man1/dh_debputy.1
	pod2man --utf8 --section=1 --name="dh_installdebputy" -c "The debputy Debian packager helper stack" dh_installdebputy \
	   $(DESTDIR)/usr/share/man/man1/dh_installdebputy.1
	devutils/install-translations
	chmod -R u=rwX,go=rX \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)/debputy

=== debian/changelog ===
debputy (0.1.80) unstable; urgency=medium

  * API:
    - *Backwards incompatibility*: Remove unused `VirtualPath.stat`
       method from the public spec. As mentioned, it was unused,
       so no breakage expected. Note that the default implementation
       still has the method, so at this point it will only be visible
       as a typing warning and not a runtime error.

  [ Nicolas Boulenguez ]
  * Improve log, warning and error messages related to the new
    `built-using` and `static-built-using` features.
  * 40+ refactor, typing fixes and other internal clean up commits
    to improve the maintainability for developers.

  [ Niels Thykier ]
  * deb_packer.py: provide closer match to `dpkg-deb` `xz` compression

 -- Niels Thykier <niels@thykier.net>  Sat, 24 Jan 2026 11:40:48 +0000

## debputy 0.1.81~bpo13+1

=== debian/changelog ===
debputy (0.1.81~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Niels Thykier <niels@thykier.net>  Sun, 08 Feb 2026 07:17:45 +0000

debputy (0.1.81) unstable; urgency=medium

  [ Niels Thykier ]
  * Add a `py.typed` file to expose typing to consumers
  * fix: crash with `dh-sequence-zz-debputy-rrr` with `dbgsym` packages.
    Thanks to Chris Hofstaedtler <zeha@debian.org> (Closes: #1126403)
  * fix: incorrect error related to `Rules-Requires-Root` in `full` mode.
    In `full` mode, building packages with static ownership would fail
    since `dpkg-buildpackage` will not pass `DEB_RULES_REQUIRES_ROOT`
    in the environment (it only applies to `debian/rules` based builds).
    With this change, `debputy` behaves like `DEB_RULES_REQUIRES_ROOT`
    was set to `no` (with a slightly different warning message), since
    `debputy` is here to support "rootless" builds

  [ Nicolas Boulenguez ]
  * 19 refactor, typing fixes and other internal clean up commits
    to improve the maintainability for developers.

 -- Niels Thykier <niels@thykier.net>  Mon, 26 Jan 2026 18:22:05 +0000

=== e2e-tests/arch-any-test/debian/changelog ===
test-source (0.0.1) unstable; urgency=medium

  * Test case

 -- Niels Thykier <niels@thykier.net>  Sat, 24 Jan 2026 11:40:48 +0000

=== e2e-tests/arch-any-test-static-ownership-rrr/debian/control ===
Source: test-source
Build-Depends: debputy, debhelper-compat (= 13), dh-sequence-zz-debputy-rrr
Maintainer: Niels Thykier <niels@thykier.net>
Section: misc
Rules-Requires-Root: no

Package: test-package
Architecture: any
Description: Test case
 This is a binary from a test case.
 .
 Installation is not recommended.

## debputy 0.1.81

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 # Nothing to do by default
 all:
 
-check:
+test:
 	py.test -v
 
 install:

=== e2e-tests/arch-any-test-rrr/debian/control ===
Source: test-source
Build-Depends: debputy, debhelper-compat (= 13), dh-sequence-zz-debputy-rrr
Maintainer: Niels Thykier <niels@thykier.net>
Section: misc

Package: test-package
Architecture: any
Description: Test case
 This is a binary from a test case.
 .
 Installation is not recommended.

=== e2e-tests/arch-any-test-static-ownership/debian/control ===
Source: test-source
Build-Depends: debputy
Build-Driver: debputy
Maintainer: Niels Thykier <niels@thykier.net>
Section: misc
Rules-Requires-Root: no

Package: test-package
Architecture: any
Description: Test case
 This is a binary from a test case.
 .
 Installation is not recommended.

## debputy 0.1.82~bpo13+1

=== e2e-tests/arch-any-test/Makefile ===
#!/usr/bin/make -f

all: test-elf

test-elf: test-elf.c
	$(CC) $(CFLAGS) $(LDFLAGS) test-elf.c -o test-elf

install: test-elf
	install -m0755 -Dt$(DESTDIR)/usr/bin test-elf

=== debian/changelog ===
debputy (0.1.82~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Niels Thykier <niels@thykier.net>  Sat, 21 Feb 2026 09:31:43 +0000

debputy (0.1.82) unstable; urgency=medium

  * Plugin API Change:
    - *Backwards incompatibility*: Remove unused
       `VirtualPath.is_detached` property from the public spec. As mentioned,
       it was unused, so no breakage expected. Note that the default
       implementation still has the method, so at this point it will only
       be visible as a typing warning and not a runtime error.

  * LSP/Lint:
    - Fix invalid structure sent via LSP protocol for document links. This
      could cause errors in the editor when the feature was used.
    - Fix missing `@` at the end of some `d/watch` variables, which would
      make `debputy` highlight and complete the variables wrongly.

  [ Nicolas Boulenguez ]
  * 15 refactor, typing fixes and other internal clean up commits
    to improve the maintainability for developers.

  [ Niels Thykier ]
  * docs: Remove obsolete warning about `lint --spellcheck --auto-fix`
  * debputy: fix crash if library was materialised before `dpkg-shlibdeps`
    Thanks to Nicolas Boulenguez <nicolas@debian.org> for reporting
    the bug and providing a minimal reproducer. (Closes: #1127427)

 -- Niels Thykier <niels@thykier.net>  Mon, 09 Feb 2026 19:30:52 +0000

=== e2e-tests/bug-1127427-arch-any-library-shlibs/debian/control ===
Source: bar
Section: music
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: debputy (>= 0.1.45~), dpkg-dev (>= 1.22.7~)
Build-Driver: debputy
Standards-Version: 4.7.3

Package: libfoo0
Section: libs
Architecture: any
Description: bla
 bla

Package: bar
Architecture: any
Description: bla
 bla

Package: libfoo-dev
Section: libdevel
Architecture: any
Depends: libfoo0 (= ${binary:Version})
Description: bla
 bla

## debputy 0.1.82

=== e2e-tests/bug-1127427-arch-any-library-shlibs/Makefile ===
exec := bar
sofile := libfoo.so.0.0.0
all: $(exec)
$(exec): $(sofile)
$(sofile): foo.o
	gcc -shared -o $@ -Wl,-soname,libfoo.so.0 $(LDFLAGS) $^ $(LDLIBS)
install: all
	install -Dt$(DESTDIR)/usr/bin $(exec)
	install -Dt$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH) $(sofile)
	cd $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH) && ln -s $(sofile) libfoo.so.0
	cd $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH) && ln -s libfoo.so.0 libfoo.so
clean:
	rm -f *~ *.o $(sofile) $(exec) debian/files
	rm -fr debian/.debputy debian/tmp

=== e2e-tests/bug-1127427-arch-any-library-shlibs/debian/changelog ===
bar (1) UNRELEASED; urgency=medium

  * Reproducer for a debputy bug.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 08 Feb 2026 12:50:27 +0100

## debputy 0.1.83

=== Makefile ===
--- 
+++ 
@@ -10,6 +10,7 @@
 
 test:
 	py.test -v
+	e2e-tests/run-tests "$(CURDIR)"
 
 install:
 	install -m0755 -Dt$(DESTDIR)/usr/bin dh_debputy dh_installdebputy assets/debputy
@@ -28,11 +29,11 @@
 	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy/version.py
 	find $(DESTDIR)/usr/share/dh-debputy -type d -name '__pycache__' -exec rm -fr {} +
 	install -m0755 -d $(DESTDIR)/usr/share/man/man1
-	pod2man --utf8 --section=1 --name="debputy" -c "The debputy Debian packager helper stack" debputy.pod \
+	pod2man --utf8 --section=1 --name="debputy" -c "The debputy Debian packaging helper stack" debputy.pod \
 	   $(DESTDIR)/usr/share/man/man1/debputy.1
-	pod2man --utf8 --section=1 --name="dh_debputy" -c "The debputy Debian packager helper stack" dh_debputy \
+	pod2man --utf8 --section=1 --name="dh_debputy" -c "The debputy Debian packaging helper stack" dh_debputy \
 	   $(DESTDIR)/usr/share/man/man1/dh_debputy.1
-	pod2man --utf8 --section=1 --name="dh_installdebputy" -c "The debputy Debian packager helper stack" dh_installdebputy \
+	pod2man --utf8 --section=1 --name="dh_installdebputy" -c "The debputy Debian packaging helper stack" dh_installdebputy \
 	   $(DESTDIR)/usr/share/man/man1/dh_installdebputy.1
 	devutils/install-translations
 	chmod -R u=rwX,go=rX \

=== debian/changelog ===
debputy (0.1.83) unstable; urgency=medium

  * LSP/Lint:
    - Recognise `Name` and `Contact` in `d/upstream/metadata`

  [ Nicolas Boulenguez ]
  * Improve end-to-end tests to include a `autoconf`-like library build.
  * Correct the `libdir` passed to `autoconf`-like build systems
  * Fix crash with `dest-dir` in `install-doc` rule.

  [ Niels Thykier ]
  * dh_*: Add introspection hints for `debhelper`
  * debputy: provide better error messages for invalid dates in
    parsed in `debian/changelog`.
    Thanks to Nilesh Patra <nilesh@debian.org>
  * d/control: (Build-)Depend on `python3-debian (>= 1.1.0~)` to
    replace vendored code now that it has fully been merged back.
    As a side-effect, restrict our CI testing to match OSes that
    can provide `python3-debian`.
  * Makefile: Run e2e-tests as a part of the build tests
  * d/tests/control: Add a test for e2e-tests

 -- Niels Thykier <niels@thykier.net>  Sat, 28 Feb 2026 07:43:19 +0000

=== debian/control ===
Source: debputy
Section: devel
Maintainer: Debputy Maintainers <debputy@packages.debian.org>
Uploaders:
 Niels Thykier <niels@thykier.net>,
Build-Depends:
# The `debhelper-compat` is only used for tests, but it
# does not allow `<!nocheck>`.
 debhelper-compat (= 13),
#               man-db <pkg.debputy.ci>,
 dh-sequence-single-binary,
 hunspell-en-us <!nocheck>,
 python3-colored <!pkg.debputy.minimal>,
 python3-colorlog <!pkg.debputy.minimal>,
 python3-debian (>= 1.1.0~),
 python3-hunspell <!nocheck>,
 python3-levenshtein <pkg.debputy.ci>,
 python3-lsprotocol <!nocheck>,
 python3-polib <pkg.debputy.test-coverage pkg.debputy.developer-dependencies>,
 python3-pygls <!nocheck !pkg.debputy.minimal-tests>,
 python3-pytest <!nocheck>,
 python3-pytest-asyncio <!nocheck>,
 python3-pytest-cov <pkg.debputy.test-coverage>,
 python3-ruyaml | python3-ruamel.yaml,
#               debputy-plugin-foo,
# The code was never checked with an older version than 3.11...
 python3:any (>= 3.11~),
 strip-nondeterminism <!nocheck>,
Rules-Requires-Root: no
X-Style: black
Standards-Version: 4.7.2
Homepage: https://salsa.debian.org/debian/debputy
Vcs-Git: https://salsa.debian.org/debian/debputy.git
Vcs-Browser: https://salsa.debian.org/debian/debputy

Package: dh-debputy
Architecture: all
Depends:
 debhelper,
 dwz <!pkg.debputy.minimal>,
 man-db <!pkg.debputy.minimal>,
# The colors dependencies are not necessary for debputy to work.
# However, to have coloring work, we need to use Depends because
# Recommends/Suggests are not resolved for builds and this should
# "just work" for users.
 python3-colored <!pkg.debputy.no-color>,
 python3-colorlog <!pkg.debputy.no-color>,
 python3-debian (>= 1.1.0~),
 python3-ruyaml | python3-ruamel.yaml,
# The code was never checked with an older version than 3.11...
 python3:any (>= 3.11~),
 strip-nondeterminism,
Recommends:
 python3-argcomplete,
Suggests:
 debputy-lsp,
 hunspell-en-us,
 python3-hunspell,
 python3-junit.xml,
 python3-levenshtein,
 python3-lsprotocol,
 python3-pygls,
Provides:
 debputy (= ${binary:Version}),
 debputy-plugin-gnome,
 debputy-plugin-grantlee,
 debputy-plugin-numpy3,
 debputy-plugin-perl-openssl,
 dh-sequence-debputy (= ${binary:Version}),
 dh-sequence-installdebputy (= ${binary:Version}),
 dh-sequence-zz-debputy (= ${binary:Version}),
 dh-sequence-zz-debputy-rrr (= ${binary:Version}),
Breaks:
# LSP/lint FP (deputy#120)
 debhelper (<= 13.19~),
Multi-Arch: foreign
Description: Manifest style Debian-based package builder (debhelper integration)
 Package builder that provides a declarative manifest for building Debian-based
 packages.
 .
 The debputy package builder aims to reduce cognitive load for the packager
 and provide better introspection to packagers, linters and the Debian
 janitor.
 .
 The debputy package also provides its own linting and editor support features
 via the debputy-lsp package that are aimed at as-you-type feedback.
 .
 This version integrates with the debhelper sequencer dh. Multiple integration
 modes are possible with dh. The most trivial integration mode is
 dh-sequence-zz-debputy-rrr, which is a mostly standard dh sequence with very
 few changes aimed entirely at removing the need for fakeroot when assembling
 the .deb.
 .
 For more information on all integration modes and what they do, please see
 https://salsa.debian.org/debian/debputy/-/blob/main/INTEGRATION-MODES.md

=== debian/tests/control ===
Tests:
 debputy-py.test,
Restrictions:
 allow-stderr,
# debputy loads the libcap2 library directly for one of the tests
Depends:
 libcap2,
 python3-all,
 python3-lsprotocol,
 python3-pytest,
 @,

Tests:
 debputy-cli,
Restrictions:
 allow-stderr,
 superficial,
Depends:
 @,

Tests:
 debputy-cli-lint-lsp,
Restrictions:
 allow-stderr,
 superficial,
Depends:
 python3-lsprotocol,
 @,

Tests:
 debputy-cli-lsp,
Restrictions:
 allow-stderr,
 superficial,
Depends:
 python3-lsprotocol,
 python3-pygls,
 @,

Test-Command: e2e-tests/run-tests installed

=== e2e-tests/arch-any-test/debian/control ===
Source: test-source
Build-Depends: debputy
Build-Driver: debputy
Maintainer: Niels Thykier <niels@thykier.net>
Section: misc

Package: test-package
Architecture: any
Description: Test case
 This is a binary from a test case.
 .
 Installation is not recommended.

=== e2e-tests/bug-1127427-arch-any-library-shlibs/debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: bar
 Section: music
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: debputy (>= 0.1.45~), dpkg-dev (>= 1.22.7~)
+Build-Depends: debputy, dpkg-dev
 Build-Driver: debputy
 Standards-Version: 4.7.3
 
@@ -20,5 +20,12 @@
 Section: libdevel
 Architecture: any
 Depends: libfoo0 (= ${binary:Version})
+ ,libbasic0 (= ${binary:Version})
 Description: bla
  bla
+
+Package: libbasic0
+Section: libs
+Architecture: any
+Description: bla
+ bla
